/*
  h_file.h   Nov98  JS  ---  please look at h_file.c for more infos
  
*/
#ifndef _H_FILE_H
#define _H_FILE_H

#include "config.h"
#include "defs.h"

/* ----------    packed-struct-array  -----------------------
 * __sparc-gcc2.7.2.3:    cplx=20Byte buserror in nhm hxy.r=r;
 * __sgi-CC: no __attribute__ 
 * __hp9000s800-gcc2.7.0: cplx=20Byte buserror in nhm hxy.r=r;
 * __alpha_ev5__-gcc2.95.2: cplx=20Byte unaligned trap at ... (/proc/kmsg)
 * better use 2D-array (struct of char[3],...) and own assignment-operator
 * struct thxy { char xy[S_int], r[S_char] } + casting-operatoren
 */
#if 1 || (! defined(__i386)) || (! defined(__GNUC__)) /* CC without packed */
#define PACK
#else
#define PACK  __attribute__ ((packed))
#endif
#define PACK_HXY 1	/* new compatible version (define/undef) */
#if 0			/* for test, future version */
#define STORE_XandY 1   /* store XR (filesize/2) or XYR (simpler) in h-file */
#endif
/*
  if HRMAX greater than 0,
  the program stores a index to the double or complex value of the matrix
  element, else the matrix element itself is stored to the disk
 --- if an error apears, choose xy as a next larger type ---
 --- please edit HRMAX too !!! ---
 unsigned char , unsigned int , ULong , ULLong
 */
#ifndef HRMAX		/* can be defined in config.h */
#define HRMAX   255  	/* 255, 1024 or higher, if ERR(9100) */
#endif
#if HRMAX<256
#define HR_TYPE	unsigned char	/* char bis 256 */
#elif HRMAX<65536
#define HR_TYPE	unsigned short	/* short bis 65536 */
#else
#define HR_TYPE	unsigned int	/* int bis 256^4 */
#endif
#define XY_TYPE unsigned int	/* int or long  14Jan00 wegen 64bittern */
#define XY_FLAG (((XY_TYPE)1)<<(sizeof(XY_TYPE)*8-1))	/* bit for last element in a line of H */ 
#ifdef PACK_HXY
struct thxy {			/* y,h[x,y] if(x=y)x++;   */
   char xy[sizeof(XY_TYPE)];	/* spalte y des NZ-Elements h[] (32bit) */
#ifdef STORE_XandY
   char xx[sizeof(XY_TYPE)];	/* zeile  x des NZ-Elements h[] (32bit) */
#endif
#if HRMAX>0
   char r[sizeof(HR_TYPE)];	/* index to NZ-Element (unsigned char,short,int) */
#else      
   char r[sizeof(mcplx)];       /* NZ- oder Diag-Element h[x,y] */
#endif
};  /*  PACK   GNUC + S_long=8 + S_mcplx=4 align=12<16 to save memory */
#else
struct thxy {			/* y,h[x,y] if(x=y)x++;   */
   XY_TYPE xy PACK ;		/* spalte y des NZ-Elements h[] (32bit) */
#ifdef STORE_XandY
   XY_TYPE xx PACK ;            /* zeile  x des NZ-Elements h[] (32bit) */
#endif
#if HRMAX>0
   HR_TYPE r PACK ;		/* index to NZ-Element (unsigned char,short,int) */
#else      
   mcplx r   PACK ;             /* NZ- oder Diag-Element h[x,y] */
#endif
};  /*  PACK   GNUC + S_long=8 + S_mcplx=4 align=12<16 to save memory */
#endif

extern int h_error;   /* set on write-error */

/* put_h fills a write buffer, this fkt writes the buffer out! */
int flush_h(int block);  /* store in file */

/* store H-element, block, column=xy+Flag_next_line, value */
void put_h(int block,ULong xy,cplx r);

int get_h(int block,ULong *xy, cplx *r);

void ini_thxy(ULong n1);
/* if vvv outut info */
void close_thxy(int vvv);
void restore_thxy(int vvv);
#endif
