#ifndef lintab_h 	/* include this only once */
#define lintab_h 1

#include "modeldef.h"
#include "defs.h"
#include "spins.h"

/* definition of the vakuum state */
#define TBASE0 ((tbase)0)

/* ================= inline - functions ======================= */

/* diese Funktion soll das Programm uebersichtlicher machen */
/* sie liefert up und down spin des Platzes i, 0=leer, 1=up, ... */
static inline int geti(tbase kfg,int i){   /* -> 0,1=u,2=d,3=du */
#if CM(1,0,0)
  return 1+(int)(1&(kfg>>i));}
#elif code2
  return( (int)(1&(kfg>>i))+2*(int)(1&(kfg>>(i+NN))) );}
#else
  return( (int)3&(kfg>>i>>i) );}
#endif

/* diese Funktion soll das Programm uebersichtlicher machen Jan00 */
/* sie setzt up und down spin am Platz i, 0=leer, 1=up, ... */
static inline tbase puti(tbase kfg,int i,int s){   /* -> 0,1=u,2=d,3=du */
#if CM(1,0,0)
  return (kfg & ~((tbase)1<<i)) | ((tbase)(s-1))<<i; }
#elif code2
  return ( (kfg & ~(((tbase1)1)<< i    )) | ((tbase1)( s    &1))<< i
         | (kfg & ~(((tbase1)1)<<(i+NN))) | ((tbase1)((s>>1)&1))<<(i+NN) );}
#else
  return (kfg & ~(((tbase)3)<<(2*i))) | ((tbase)s)<<(2*i);}
#endif
        

/* fast encode ud[] to cfg, 0 1=u 2=d 3=du ud[0]=lowest Dez01 */
static inline void encode_ud(tbase *kfg,char ud[NN],int nn){
  int i; *kfg=TBASE0;
#if CM(1,0,0)
  for(i=nn-1;i>=0;i--) (*kfg) = ((*kfg)<<1) | ((tbase)(ud[i]-1));
#elif code2
  for(i=0;i<nn;i++) { (*kfg) |= ((tbase1)( ud[i]    &1))<< i
                             |  ((tbase1)((ud[i]>>1)&1))<<(i+NN); }
#else
  for(i=0;i<nn;i++)   (*kfg) |= ((tbase)ud[i])<<(2*i);
#endif
}

#if CM(0,1,1)
/* fast xor single spin i ud=0: u, ud=1: d, Apr02 */
static inline tbase tbase_xor(tbase kfg, int i, int ud){
#if CM(1,0,0)
  kfg ^= (((tbase)1)<<i);    /* ud not used!? */
#elif code2
  kfg ^= (((tbase)1)<<(i+NN*ud));
#else
  kfg ^= (((tbase)1)<<(2*i+ud));
#endif
  return kfg;
}
#endif

int b_out(struct sbase *b,int len);
zahl makesym(tvec *v0,tvec *v1,int d,int kk);
void   paini();
ULLong numsymkonf();
ULLong numkonf();
void lintab2(void);
tbase  ll1(ULLong ii); /* only for ll1(0) ??? */
int initmasks(int nn);

#endif
